/* Created BY Deepanker Verma deepanker70@gmail.com
 */
import java.sql.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public class MainForm extends JFrame implements ActionListener,KeyListener,WindowListener
{
	private Connection connection;
	
	public void openConnection()
	{
		try
		{
			File file=new File("Database");
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
			this.connection=DriverManager.getConnection("jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ="+file.getAbsolutePath()+"\\Database.mdb");
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(this,e.getMessage());
		}
	}
	public void closeConnection()
	{
		try
		{
			if(!this.connection.isClosed())
			{
				this.connection.close();
			}
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(this,e.getMessage());
		}
	}
	
	private JPanel p1,p2,p3,p4,p5;
	private JLabel l1,l2,l3,l4,l5;
	private JLabel l6,l7,l8,l9,l10,l11;
	private JLabel l12,l13,l14;
	
	private JTextField txt1,txt2,txt3,txt4,txt5;
	private JTextField txt6,txt7,txt8,txt9,txt10,txt11;
	private JTextField txt12,txt13,txt14;
	
	private JButton cmd1,cmd2,cmd3,cmd4,cmd5;
	private JTextArea text1,text2;
	
	private Container c;
	
	private void initTextArea()
	{
		text1=new JTextArea("ID\tNAME\t\tCONTACT\tFEE\tTOPIC\tDATE",5,5);
		text1.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		text2=new JTextArea("FEE ID\tSTUDENT ID\t\tAMOUNT\t\tDATE",5,5);
		text2.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		this.setFeeDetails(0);
	}
	private void initButton()
	{
		cmd1=new JButton("Create");
		cmd1.addActionListener(this);
		
		cmd2=new JButton("Show All Students");
		cmd2.addActionListener(this);
		
		cmd3=new JButton("Modify");
		cmd3.addActionListener(this);
		
		cmd4=new JButton("Delete");
		cmd4.addActionListener(this);
		
		cmd5=new JButton("Save Payment");
		cmd5.addActionListener(this);
	}
	private void initLabel()
	{
		
		l1=new JLabel("Name");
		l2=new JLabel("Contact");
		l3=new JLabel("Total Fee");
		l4=new JLabel("Topic");
		l5=new JLabel("Join Date");
		
		l11=new JLabel("Student ID");
		l6=new JLabel("Name");
		l7=new JLabel("Contact");
		l8=new JLabel("Total Fee");
		l9=new JLabel("Topic");
		l10=new JLabel("Join Date");
		
		l12=new JLabel("Sudent ID");
		l13=new JLabel("Amount");
		l14=new JLabel("Date");
		
	}
	private void initTextBox()
	{
		txt1=new JTextField(10);
		txt2=new JTextField(10);
		txt3=new JTextField(10);
		txt4=new JTextField(10);
		txt5=new JTextField(10);
		
		txt6=new JTextField(10);
		txt7=new JTextField(10);
		txt8=new JTextField(10);
		txt9=new JTextField(10);
		txt10=new JTextField(10);
		txt11=new JTextField(10);
        txt11.addKeyListener(this);
		
		txt12=new JTextField(5);
		txt13=new JTextField(5);
		txt14=new JTextField(5);
	}
	private void initPanel()
	{
		this.initButton();
		this.initLabel();
		this.initTextBox();
		this.initTextArea();
		
		p1=new JPanel();
		p1.setBorder(BorderFactory.createTitledBorder("Create Student"));
		p1.setLayout(new GridLayout(6,2,5,5));
		p1.add(l1);
		p1.add(txt1);
		p1.add(l2);
		p1.add(txt2);
		p1.add(l3);
		p1.add(txt3);
		p1.add(l4);
		p1.add(txt4);
		p1.add(l5);
		p1.add(txt5);
		p1.add(cmd2);
		p1.add(cmd1);
		
		
		p2=new JPanel();
		p2.setBorder(BorderFactory.createTitledBorder("Modify/Delete Student"));
		p2.setLayout(new GridLayout(7,2,5,5));
		
		p2.add(l11);
		p2.add(txt11);
		p2.add(l6);
		p2.add(txt6);
		p2.add(l7);
		p2.add(txt7);
		p2.add(l8);
		p2.add(txt8);
		p2.add(l9);
		p2.add(txt9);
		p2.add(l10);
		p2.add(txt10);		
		p2.add(cmd3);
		p2.add(cmd4);
		
		p3=new JPanel();
		p3.setBorder(BorderFactory.createTitledBorder("All Student Details"));
		p3.setLayout(new GridLayout(1,1));
		p3.add(text1);
				
		p4=new JPanel();
		p4.setBorder(BorderFactory.createTitledBorder("Fee Submmission"));
		p4.setLayout(new GridLayout(2,1,5,5));
		p4.add(new JScrollPane(text2));
		
		p5=new JPanel();
		p5.setBorder(BorderFactory.createTitledBorder("New Fee Details"));
		p5.setLayout(new FlowLayout());
		
		p5.add(l12);
		p5.add(txt12);
		
		p5.add(l13);
		p5.add(txt13);
		
		p5.add(l14);
		p5.add(txt14);
		
		p5.add(cmd5);
		
		p4.add(p5);
	}
	private void initComponent()
	{
		this.initPanel();
		c=this.getContentPane();
		c.setLayout(new GridLayout(2,2));
		c.add(p1);
		c.add(p2);
		c.add(p3);
		c.add(p4);	
		
		this.addWindowListener(this);
        
	}
        //---------------------CONSTRUCTOR---------------------------------
	public MainForm()
	{
		this.setTitle("Shah Tutorial Management System..."+(new java.util.Date()));
		this.initComponent();
		this.setSize(Toolkit.getDefaultToolkit().getScreenSize());
		this.setVisible(true);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.pack();
		
	}
        //-------------------EVENT HANDLERS----------------------------
	public void actionPerformed(ActionEvent ae)
        {
                if(ae.getSource()==cmd1)
                {
                        this.createStudent();
                        this.setStudentDetails();
                }
                if(ae.getSource()==cmd3)
                {
                        this.modifyStudent();
                        this.setStudentDetails();
                }
				if(ae.getSource()==cmd5)
                {
                        this.payFee();                        
                }
                if(ae.getSource()==cmd2)
                {
                        this.setStudentDetails();
                }
                if(ae.getSource()==cmd4)
                {
                        this.deleteStudent();
                        this.setStudentDetails();
                }
        }
	
	public void keyPressed(KeyEvent ke){}
	public void keyReleased(KeyEvent ke)
        {
                if(!txt11.getText().trim().equals(""))
                {
                        String StudentID=txt11.getText().trim();
                        try
                        {
                                PreparedStatement ps=connection.prepareStatement("Select * From StudentMaster Where StudentID=?");
                                ps.setInt(1,Integer.parseInt(StudentID));
                                ResultSet rs=ps.executeQuery();
                                if(rs.next())
                                {
                                        txt11.setText(rs.getInt(1)+"");
                                        txt6.setText(rs.getString(2)+"");
                                        txt7.setText(rs.getString(3)+"");
                                        txt8.setText(rs.getDouble(4)+"");
                                        txt9.setText(rs.getString(5)+"");
                                        txt10.setText(rs.getString(6)+"");
                                }                                        
                                rs.close();
                                this.setFeeDetails(Integer.parseInt(StudentID));
                        }
                        catch(Exception e)
                        {
                                JOptionPane.showMessageDialog(this,"Student Details Not Found");
                        }
                }
                else
                {
                	  txt11.setText("");
                      txt6.setText("");
                      txt7.setText("");
                      txt8.setText("");
                      txt9.setText("");
                      txt10.setText("");
                      this.setFeeDetails(0);
                     
                }

        }
	public void keyTyped(KeyEvent ke){}
	
	public  void windowClosing(WindowEvent we)
        {
                this.closeConnection();
        }
    public  void windowClosed(WindowEvent we){}
    public  void windowActivated(WindowEvent we){}
    public  void windowDeactivated(WindowEvent we){}
    public  void windowIconified(WindowEvent we){}
    public  void windowDeiconified(WindowEvent we){}
    public  void windowOpened(WindowEvent we)
        {
                this.openConnection();
        }
    //----------------------MAIN BLOCK--------------------------------
    public static void main(String [] args)
	{
		MainForm p=new MainForm();
		try
		{
			UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			SwingUtilities.updateComponentTreeUI(p);
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(p,e.toString());
		}
	}
    //---------------------DATABASE HANDLERS--------------------------
    public void createStudent()
        {
                try
                {
                        String str="INSERT INTO STUDENTMASTER (NAME,CONTACT,TOTALFEE,TOPIC,JOINDATE) VALUES(?,?,?,?,?)";
                        PreparedStatement ps=this.connection.prepareStatement(str);
                        ps.setString(1,txt1.getText().toUpperCase().trim());
                        ps.setString(2,txt2.getText().toUpperCase().trim());
                        ps.setDouble(3,Double.parseDouble(txt3.getText().trim()));
                        ps.setString(4,txt4.getText().toUpperCase().trim());
                        ps.setString(5,txt5.getText().toUpperCase().trim());
                        int a=ps.executeUpdate();
                        if(a>0)
                        {
                                JOptionPane.showMessageDialog(this,"Student Added In The Database");
                                txt1.setText("");
			                    txt2.setText("");
			                    txt3.setText("");
			                    txt4.setText("");
			                    txt5.setText("");
			                    txt6.setText("");
		                }

                }
                catch(Exception e)
                {
                        JOptionPane.showMessageDialog(this,e.getMessage());
                }
        }
    public void modifyStudent()
        {
                try
                {
                        String str="UPDATE STUDENTMASTER SET NAME=?,CONTACT=?,TOTALFEE=?,TOPIC=?,JOINDATE=? WHERE STUDENTID=?";
                        PreparedStatement ps=this.connection.prepareStatement(str);
                        ps.setString(1,txt6.getText().toUpperCase().trim());
                        ps.setString(2,txt7.getText().toUpperCase().trim());
                        ps.setDouble(3,Double.parseDouble(txt8.getText().trim()));
                        ps.setString(4,txt9.getText().toUpperCase().trim());
                        ps.setString(5,txt10.getText().toUpperCase().trim());
                        ps.setInt(6,Integer.parseInt(txt11.getText().trim()));
                        int a=ps.executeUpdate();
                        if(a>0)
                        {
                                JOptionPane.showMessageDialog(this,"Student Updated In The Database");
                                txt11.setText("");
                      			txt6.setText("");
                      			txt7.setText("");
                      			txt8.setText("");
                      			txt9.setText("");
                      			txt10.setText("");
                      			txt11.requestFocus();
                        }
                        else
                        {
                                JOptionPane.showMessageDialog(this,"Student Not Updated In The Database");
                        }

                }
                catch(Exception e)
                {
                        JOptionPane.showMessageDialog(this,e.getMessage());
                }
        }
    public void deleteStudent()
        {
                try
                {
                        String str="DELETE FROM STUDENTMASTER WHERE STUDENTID=?";
                        PreparedStatement ps=this.connection.prepareStatement(str);
                        ps.setInt(1,Integer.parseInt(txt11.getText().trim()));
                        int a=ps.executeUpdate();
                        if(a>0)
                        {
                                JOptionPane.showMessageDialog(this,"Student Deleted In The Database");
                                txt11.setText("");
                      			txt6.setText("");
                      			txt7.setText("");
                      			txt8.setText("");
                      			txt9.setText("");
                      			txt10.setText("");
                      			txt11.requestFocus();
                        }
                        else
                        {
                                JOptionPane.showMessageDialog(this,"Student Not Deleted In The Database");
                        }

                }
                catch(Exception e)
                {
                        JOptionPane.showMessageDialog(this,e.getMessage());
                }
        }
    public void payFee()
    {
    	try
    	{
    		String str="INSERT INTO FEEMASTER (STUDENTID,AMOUNT,PAYDATE) VALUES(?,?,?)";
    		PreparedStatement ps=connection.prepareStatement(str);
    		ps.setInt(1,Integer.parseInt(txt12.getText().trim()));
    		ps.setDouble(2,Double.parseDouble(txt13.getText().trim()));
    		ps.setString(3,txt14.getText().trim());
    		int a=ps.executeUpdate();
    		if(a>0)
    		{
    			JOptionPane.showMessageDialog(this,"Fee Payment Recorded");
    			this.setFeeDetails(Integer.parseInt(txt12.getText().trim()));
    		}
    		else
    		{
    			JOptionPane.showMessageDialog(this,"Fee Payment Not Recorded");
    		}
    		txt12.setText("");
    		txt13.setText("");
    		txt14.setText("");
    		txt12.requestFocus();
    	}
    	catch(Exception e)
    	{
    		JOptionPane.showMessageDialog(this,e.getMessage());
    	}
    }
    public void setFeeDetails(int StudentID)
    {
    	try
    	{
    		String str="FEE ID\tSTUDENT ID\t\tAMOUNT\t\tDATE";
    		PreparedStatement ps=null;
    		if(StudentID==0)
    		{
    			ps=connection.prepareStatement("Select FEEID,STUDENTID,AMOUNT,PAYDATE From FEEMASTER");
    		}
    		else
    		{
    			ps=connection.prepareStatement("Select FEEID,STUDENTID,AMOUNT,PAYDATE From FEEMASTER WHERE STUDENTID=?");
    			ps.setInt(1,StudentID);
    		}
    			
    		
    		ResultSet rs=ps.executeQuery();
    		while(rs.next())
    		{
    			str+="\n"+rs.getInt(1)+"\t"+rs.getInt(2)+"\t\t"+rs.getDouble(3)+"\t\t"+rs.getString(4);
    		}
    		text2.setText(str);   			
    			
    	}
    	catch(Exception e){}
    }
    public void setStudentDetails()
    {
    	try
    	{
    		String sql="Select * From StudentMaster";
    		PreparedStatement ps=connection.prepareStatement(sql);
    		ResultSet rs=ps.executeQuery();
    		String str="ID\tNAME\t\tCONTACT\tFEE\tTOPIC\tDATE";
    		while(rs.next())
    		{
    			str+="\n"+rs.getInt(1)+"\t"+rs.getString(2)+"\t\t"+rs.getString(3)+"\t"+rs.getDouble(4)+"\t"+rs.getString(5)+"\t"+rs.getString(6);
    		}
    		text1.setText(str);
    	}
    	catch(Exception e){}
    }
}
